﻿doc = app.activeDocument;
sel = doc.selection;

first = 1;
ang = 0;
for(i=0; i<sel.length; i++)
{
	if(sel[i].typename == "GroupItem" || sel[i].typename == "PathItem" || sel[i].typename == "CompoundPathItem")
	{
		currGroup = sel[i];
		
		getFP = FindFirstPath(currGroup);
		currpath = getFP[1];
	
		if(getFP[0] == 1)
		{
			p1 = currpath.pathPoints[0].anchor;
			p2 = currpath.pathPoints[1].anchor;
			
			deltax = p1[0]-p2[0];
			deltay = p1[1]-p2[1];
			
			currang = Math.atan(deltay/deltax);
			if(deltax<0)
				currang+=Math.PI;
			
			if(first)
			{
				first = 0;
				
				ang = currang;
			}
			else
			{
				currGroup.rotate((ang-currang)*180/Math.PI);	
			}
		}
	}
}

function FindFirstPath(workGroup)
{
	if(workGroup.typename == "PathItem")
		return [1, workGroup];
		
	if(workGroup.typename == "CompoundPathItem")
		return [1, workGroup.pathItems[0]];
	
	nSubPathes = workGroup.pathItems.length;
	if(nSubPathes > 0)
			return [1, workGroup.pathItems[0]];
		
	nSubPathes = workGroup.compoundPathItems.length;
	if(nSubPathes > 0)
			return [1, workGroup.compoundPathItems[0].pathItems[0]];

	nSubGroups = workGroup.groupItems.length;
	if(nSubGroups==0)
		return [0, 0];
	var currRet = [0, 0];
	for(iGroup=0; iGroup<nSubGroups; iGroup++)
	{
		currRet = FindFirstPath(workGroup.groupItems[iGroup]);
		if(currRet[0]==1)
			break;
	}
	return currRet;
}